/*
Autor solutie: Verestiuc Daniel-Silviu
Unitate de invatamant: Scoala Gimnaziala `George Calinescu` - Iasi

Descriere solutie:
- Citim numarul de cartonase apoi il divizam cu 2 ca sa putem citi n/2 perechi de cartonase
- Repetam pasii urmatori pana la finalizarea citirii tuturor cartonaselor:
    - Citim primul numar de pe cartonas, apoi aflam restul impartirii la 100, pentru a determina ultimele 2 cife.
    - Citim cel de-al doilea numar din pereche, si il divizam cu 10 pana cand acesta devine mai mic strict decat 100.
    - Vedem numarul nou format cu formula x1 * 100 + x2
    - Facem o copie a acestuia apoi aflam suma cifelor pare si impare
    - Daca numarul obtinut este special, atunci comparam cu maximul numarului special curent si actualizam, eventual, maximul.
        ** initial max este 0 deoarece este imposibil ca prin combinarea numerelor de pe cartonase sa ibtinem un numar nul (cel mai mic numar posibil ar fi 10).
    - La final maximul este scris in fisier.
*/


#include <iostream>
#include <fstream>

using namespace std;

int main()
{
    unsigned long long int x1, x2;
    unsigned long      int n, max=0;
    unsigned short     int numar, copie;
    unsigned char          suma_p, suma_i;
    ifstream fisier_in;
    ofstream fisier_out;

    fisier_in.open("specialmax.in");
    fisier_out.open("specialmax.out");

    // Veriifcam daca fisierele au fost deschise corespunzator si oprim executia programului in caz contrar
    if(!fisier_in){
        cout << "Fisierul de intrare nu a putut fi deschis cu succes.";
        return 0;
    }
    if(!fisier_out){
        cout << "Fisierul de iesire nu a putut fi deschis cu succes.";
        return 0;
    }

    // Citim numarul de cartonase disponibile si il divizam cu 2.
    fisier_in >> n;
    n /= 2;

    // Citim n/2 perechi de cartonase
    for(int i=0; i<n; i++){
        // Citim primul numar si calculam ultimele 2 cifre
        fisier_in >> x1;
        x1 = x1 % 100;

        // Citim cel de-al doilea numar si calulam primele 2 cifre ale acestuia.
        // impartim la 10 cat timp numarul este mai mare decat 100.
        fisier_in >> x2;
        while (x2 > 100){
            x2 = x2/10;
        }

        // Pentru a adauga x1 la inceputul numarului nou creat
        // trebuie sa il inmultim cu 100
        // apoi adaugam numarul x2
        numar = x1*100 + x2;

        // facem o copie a numarului curent
        // apoi calculam sumele cifelor pare si impare
        copie  = numar;
        suma_p = 0;
        suma_i = 0;
        while(copie != 0) {
            if (copie % 2 == 0){
                // daca ultima cifra este   para, atunci o adaugam la suma cifrelor   pare
                suma_p += copie % 10;
            } else {
                // daca ultima cifra este impara, atunci o adaugam la suma cifrelor impare
                suma_i += copie % 10;
            }

            // scapam de ultima cifra, cea pe care am folosit-o, divizand copia cu 10
            copie /= 10;
        }

        // Verificam daca numarul este special (suma ciferlor pare este mai mare decat suma cifelor impare)
        if (suma_p > suma_i){
            // in cazul in care numarul este special, atunci il comparam cu maximul actual si, eventual, il actualizam
            if (numar > max){
                max = numar;
            }
        }
    }

    fisier_out << max;

    // Inchidem fisierele
    fisier_in.close();
    fisier_out.close();
    return 0;
}
