/*
  autor: Paul Diac
   timp: O(n^2)
memorie: O(n)
idee: programare dinamica + precalculare sume-stanga + matrice redusa la doua linii
punctaj: 100
*/

#include <cstdio>
#include <vector>
#define NMax 3001
#define QMax 100001
#define MOD 1000003
using namespace std;

typedef struct query {
    int n, st, dr, res;
} query;

int pos[2][6 * NMax]; // pos[n%2][s] = aruncari de n zaruri cu suma = s, matricea e redusa la doua linii
int poss[2][6 * NMax]; // pos[n%2][s] = aruncari de n zaruri cu suma <= s, suma-stanga
int Q, nmax;
query q[QMax]; // parametri intrebari
vector<int> index[NMax]; // pentru q adaugam i in index[q[i].n]

int main() {
    freopen("zaruri.in", "r", stdin);
    freopen("zaruri.out", "w", stdout);

    scanf("%d", &Q);
    for (int i = 0; i < Q; i++) {
        scanf("%d %d %d", &q[i].n, &q[i].st, &q[i].dr);
        if (nmax < q[i].n) { nmax = q[i].n; }
        if (q[i].dr > q[i].n * 6) { q[i].dr = q[i].n * 6; }
        index[q[i].n].push_back(i);
    }
    pos[0][0] = 1;
    for (int ni = 1; ni <= nmax; ni++) {
        for (int s = 0; s <= ni * 6; s++) { pos[ni%2][s] = poss[ni%2][s] = 0; }
        for (int s = 1; s <= ni * 6; s++) { // de suma s
            for (int z = 1; z <= 6 && s - z >= 0; z++) { // ultimul zar
                pos[ni%2][s] += pos[(ni+1)%2][s - z];
            }
            pos[ni%2][s] %= MOD;
            poss[ni%2][s] = (poss[ni%2][s-1] + pos[ni%2][s]) % MOD;
        }
        for (int qi: index[ni]) {
            query &qr = q[qi];
            q[qi].res = (poss[ni%2][q[qi].dr] - poss[ni%2][q[qi].st-1] + MOD) % MOD; // sume-stanga
        }
    }
    for (int i = 0; i < Q; i++) {
        printf("%d\n", q[i].res);
    }
    return 0;
}
